/*yasep/core-js/base66.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
depends on core-js/txt_int.js for str2int
created 20110808 by whygee@f-cpu.org
66 characters are available as single-byte encoding
"." and "-" are reserved for use as separators.
Bug? code "E" = -0
No range check :-/
*/

//var yasep_cookies=[];
var baseLUT="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ*/_@";
var baseLUTlength=baseLUT.length;
var baseLUTlength2=baseLUTlength >> 1;

// reverse lookup:
var LUTbase=[];
for (var i=0; i<baseLUTlength; i++)
  LUTbase[baseLUT[i]]=i;

function encode_number_base66(i){
  if (typeof i=="string") {
    if (i=="")
      return "";
    i=str2int(i);
  }
  if (typeof i != 'number')
    return null;
  if (i==0)
    return "";
  var s=0;
  if (i<0){
    s=1;
    i=-i;
  }
  // LSB encoded in base/2 to add a sign
  var b=i % baseLUTlength2;
  var c=b;
  if (s!=0)
    c+=baseLUTlength2;
  var a=baseLUT[c];
  i=(i-b)/baseLUTlength2;
  // the other digits are in base66
  while (i) {
    b=i%baseLUTlength;
    a=a+baseLUT[b];
    i=(i-b)/baseLUTlength;
  }
  return a;
}

function decode_number_base66(a) {
  if (typeof a!="string")
    return null;
  if (a=="")
    return 0;
  // decode the LSB+sign
  var s=1;
  var i=LUTbase[a[0]];
  if (i>=baseLUTlength2) {
    s=-1;
    i-=baseLUTlength2;
  }
  // decode the other digits
  var j=1,k=baseLUTlength2;
  while (j<a.length) {
    i+=LUTbase[a[j++]]*k;
    k*=baseLUTlength;
  }
  return i*s;
}

// compaction function that takes a string and hashes it down to 4 chars
function hash66(s){
  var h=42, i;
  for (i in s)
    h=((h+i)*s.charCodeAt(i))% 9487363; // this prime is a bit less than (66^4)/2
  return encode_number_base66(h+2);
}

/* Call this to perform some sanity checks
function test_bases(){
  document.write("<html><body><pre>");
  for (i=-200000; i<200000; i++){
    var j=encode_number_base66(i);
    var k=decode_number_base66(j);
    if (k!=i)
      document.write(i+":"+j+"="+k+"\n");
  }
  document.write("fini!</pre><body></html>");
  document.close();
}
*/
